import { ChangedFile, CodeEngine } from "@code-engine/types";
import { DirPathInfo, FilePathInfo } from "./get-path-info";
import { NormalizedConfig } from "./normalize-config";
/**
 * Internal class that wraps the filesystem watch functionality.
 */
export declare class Watcher {
    private chokidar;
    private output;
    private config;
    private engine;
    private dir;
    private disposed;
    get iterable(): AsyncIterableIterator<ChangedFile>;
    constructor(engine: CodeEngine, path: DirPathInfo | FilePathInfo, config: NormalizedConfig);
    /**
     * Disposes the watcher. It cannot be used after this.
     */
    dispose(): Promise<void>;
    /**
     * A filesystem change was detected within the directory path.
     */
    private changeDetected;
    private errorHandler;
}
